/***
 * Excerpted from "Core Data in Objective-C, Third Edition",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit http://www.pragmaticprogrammer.com/titles/mzcd3 for more book information.
***/
/*
 
 File: MyApplication.m
 
 Abstract: Application subclass to work around a bug in AppKit.
 
 Version: 1.0
 
 Disclaimer: IMPORTANT:  This Apple software is supplied to you by Apple Inc. ("Apple") in consideration of your agreement to the following terms, and your use, installation, modification or redistribution of this Apple software constitutes acceptance of these terms.  If you do not agree with these terms, please do not use, install, modify or redistribute this Apple software.
 
 In consideration of your agreement to abide by the following terms, and subject to these terms, Apple grants you a personal, non-exclusive license, under Apple's copyrights in this original Apple software (the "Apple Software"), to use, reproduce, modify and redistribute the Apple Software, with or without modifications, in source and/or binary forms; provided that if you redistribute the Apple Software in its entirety and without modifications, you must retain this notice and the following text and disclaimers in all such redistributions of the Apple Software.  Neither the name, trademarks, service marks or logos of Apple Inc. may be used to endorse or promote products derived from the Apple Software without specific prior written permission from Apple.  Except as expressly stated in this notice, no other rights or licenses, express or implied, are granted by Apple herein, including but not limited to any patent rights that may be infringed by your derivative works or by other works in which the Apple Software may be incorporated.
 
 The Apple Software is provided by Apple on an "AS IS" basis.  APPLE MAKES NO WARRANTIES, EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, REGARDING THE APPLE SOFTWARE OR ITS USE AND OPERATION ALONE OR IN COMBINATION WITH YOUR PRODUCTS.
 
 IN NO EVENT SHALL APPLE BE LIABLE FOR ANY SPECIAL, INDIRECT, INCIDENTAL OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) ARISING IN ANY WAY OUT OF THE USE, REPRODUCTION, MODIFICATION AND/OR DISTRIBUTION OF THE APPLE SOFTWARE, HOWEVER CAUSED AND WHETHER UNDER THEORY OF CONTRACT, TORT (INCLUDING NEGLIGENCE), STRICT LIABILITY OR OTHERWISE, EVEN IF APPLE HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 
 Copyright (C) 2005-2007 Apple Inc. All Rights Reserved.
 
 */

#import "MyApplication.h"
#import "NewObjectSheetController.h"


@implementation MyApplication

- (id)targetForAction:(SEL)anAction to:(id)aTarget from:(id)sender
{
	if ((anAction != @selector(undo:)) &&
		(anAction != @selector(redo:)))
	{
		return [super targetForAction:anAction to:aTarget from:sender];
	}	
	
	id keyWindowDelegate = [[self keyWindow] delegate];
	if ([keyWindowDelegate isKindOfClass:[NewObjectSheetController class]])
	{
		return keyWindowDelegate;
	}
	return [super targetForAction:anAction to:aTarget from:sender];
}


- (BOOL)sendAction:(SEL)anAction to:(id)theTarget from:(id)sender
{
	if ((anAction != @selector(undo:)) &&
		(anAction != @selector(redo:)))
	{
		
		return [super sendAction:anAction to:theTarget from:sender];
	}
	
	id keyWindowDelegate = [[self keyWindow] delegate];
	if ([keyWindowDelegate isKindOfClass:[NewObjectSheetController class]])
	{
		return [super sendAction:anAction to:keyWindowDelegate from:sender];
	}
	return [super sendAction:anAction to:theTarget from:sender];
}

@end

